var backWidth = 220;
var backHeight = 290;
var frontWidth = 200;
var frontHeight = 200;
var backShown = false;

var tableTd = ["tc", "tr", "lc", "rc", "bl", "bc"];
var tableImg = ["tl", "br"];
var titleColors = {white: "black", yellow: "black", orange: "black", gray: "black"};
var backColors = {black: "#202020", white: "white", red: "#b90a0a", orange: "#d97505", yellow: "#E7C24A", green: "#28970e", blue: "#1f289e", gray: "#9f9f9f"};

var urls = new Array();
var lastId = 0;

var current;
var borderWidth = 60;
var borderHeight = 78;
var width = frontWidth - borderWidth;
var height = frontHeight - borderHeight;
var updateTimer;

function setup() {
  widgetSetup();
  frontWidth = window.innerWidth;
  frontHeight = window.innerHeight;
  if (window.widget) {
    createDefaultWebCams();
    if (widget.mobile) {
      var fit = widget.mobile.getResizeToFit();
      frontWidth = 274;
    }
    
    widget.onshow = onshow;
    widget.onhide = onhide;
    widget.onremove = clearPrefs;
    readPrefs();
    mobileResize();
    if (widget.context != null) {
      document.getElementById("Widgetop").style.display = "none";
    }
  }  
}

function onshow() {
  startAutoUpdate();
}

function onhide() {
  stopAutoUpdate();
}

function readPrefs() {
  var ids = widget.preferenceForKey(widget.identifier + "-urls");
  try {
    urls = eval(ids);
  }
  catch (e) {
    alert("Reload failed: e");
    urls = new Array();
  };
  if (urls && urls.length > 0) {
    reloadWebCams(urls);      
  }
  else {
    urls = new Array();
    addWebCam(predefined[0][1][0][1], predefined[0][1][0][0]);    
    addWebCam(predefined[1][1][0][1], predefined[1][1][0][0]);    
    addWebCam(predefined[1][1][2][1], predefined[1][1][2][0]);    
  }

  var refresh = widget.preferenceForKey(widget.identifier + "-refresh");
  if (refresh) {
    document.getElementById("AutoUpdate").value = refresh;
  }

  var width = widget.preferenceForKey(widget.identifier + "-width");
  if (width != null) {
    frontWidth = eval(width);    
  }
  var height = widget.preferenceForKey(widget.identifier + "-height");
  if (height != null) {
    frontHeight = eval(height);    
  }    
  resize(frontWidth, frontHeight);

  var value = widget.preferenceForKey(widget.identifier + "-color");
  if (value != null) {
    setFrontColor(value);
    document.getElementById("FrontColor").value = value;    
  }
  else {
    setFrontColor("black");
  }

  if (this.showBackSide) {
    showBack()
  }
}

function clearPrefs() {
  for (var i = 0; i < urls.length; i++) {
    widget.setPreferenceForKey(null, widget.identifier + "-url" + urls[i]);  	
    widget.setPreferenceForKey(null, widget.identifier + "-title" + urls[i]);  	
  }
  widget.setPreferenceForKey(null, widget.identifier + "-urls");
  widget.setPreferenceForKey(null, widget.identifier + "-width");
  widget.setPreferenceForKey(null, widget.identifier + "-height");
  widget.setPreferenceForKey(null, widget.identifier + "-color");
  widget.setPreferenceForKey(null, widget.identifier + "-refresh")
}

function createDefaultWebCams() {
  if (predefined) {
    for (var i = 0; i < predefined.length; i++) {
      var group = document.createElement("optgroup");
      group.label = predefined[i][0];
      for (var j = 0; j < predefined[i][1].length; j++) {
      	var option = document.createElement("option");
      	option.innerHTML = predefined[i][1][j][0];
      	option.value = predefined[i][1][j][1];
      	option.cam = predefined[i][1][j];
      	group.appendChild(option);
      }
      document.getElementById("Predefined").appendChild(group);    	
    }
  }
}

function addPredefined() {
  var predefined = document.getElementById("Predefined");
  var index = predefined.selectedIndex;
  var value = predefined.options[index].cam;
  alert(value);
  document.getElementById("TitleInput").value = value[0];
  document.getElementById("UrlInput").value = value[1];
  predefined.selectedIndex = -1;
}

function addCam() {
  var url = document.getElementById("UrlInput").value;
  var title = document.getElementById("TitleInput").value;
  if (!title || title.length == 0) {
    title = url;
  }
  addWebCam(url, title);
  hideBack();
}

function addWebCam(url, title, id) {
  if (!id) {
    lastId++;
    id = lastId;
    urls.push(id);
  }
  widget.setPreferenceForKey(url, widget.identifier + "-url" + id);  	  
  widget.setPreferenceForKey(title, widget.identifier + "-title" + id);  	  
  saveUrls();
  var element = document.createElement("div");
  element.id = "Url" + id;
  element.className = "webcam";
  element.title = "Open " + title;
  element.onmouseover = function() {
    webcamMouseOver(this);
  }   
  element.onmouseout = function() {
    webcamMouseOut(this);
  }
  var template = document.getElementById("WebCamTemplate").innerHTML;
  element.innerHTML = template.replace(/\$ID\$/g, id);
  var webcamObj = setupWebCam(id, element, url, title);
  element.webcam = webcamObj;
  document.getElementById("Cams").appendChild(element);
  loadImage(id, url);
  mobileResize();
}

function webcamMouseOver(webcamElement) {
  document.getElementById("CloseButton" + webcamElement.webcam.id).style.display = "block";
  document.getElementById("RefreshButton" + webcamElement.webcam.id).style.display = "block";
  document.getElementById("LeftButton" + webcamElement.webcam.id).style.display = "block";
  document.getElementById("RightButton" + webcamElement.webcam.id).style.display = "block";
}

function webcamMouseOut(webcamElement) {
  document.getElementById("CloseButton" + webcamElement.webcam.id).style.display = "none";
  document.getElementById("RefreshButton" + webcamElement.webcam.id).style.display = "none";
  document.getElementById("LeftButton" + webcamElement.webcam.id).style.display = "none";
  document.getElementById("RightButton" + webcamElement.webcam.id).style.display = "none";
}

function removeWebCam(element) {
  var id = element.webcam.id;
  widget.setPreferenceForKey(null, widget.identifier + "-url" + id);  	
  widget.setPreferenceForKey(null, widget.identifier + "-title" + id);  	
  for (var i = 0; i < urls.length; i++) {
  	if (urls[i] == id) {
  	  urls.splice(i, 1);
  	}
  }
  saveUrls();
  element.parentNode.removeChild(element);
  mobileResize();
}

function setupWebCam(id, element, url, title) {
  var webcam = new Object();
  webcam.id = id;
  webcam.element = element;
  webcam.url = url;
  webcam.title = title;
  //webcams["" + id] = webcam;
  return webcam;
}

function moveWebCamLeft(webcamElement) {
  var webcams = document.getElementById("Cams");
  var previous = webcamElement.previousSibling;
  if (previous != null) {
    webcams.removeChild(webcamElement);
    webcams.insertBefore(webcamElement, previous);
    var id = webcamElement.webcam.id;
    for (var i = 0; i < urls.length; i++) {
    	if (urls[i] == id && i > 0) {
  	    var old = urls[i - 1];
  	    urls[i - 1] = id;
  	    urls[i] = old;
  	    break;
  	  }
    }  
  }
  saveUrls();
}

function moveWebCamRight(webcamElement) {
  var webcams = document.getElementById("Cams");
  var next = webcamElement.nextSibling;
  if (next != null) {
    webcams.removeChild(next);
    webcams.insertBefore(next, webcamElement);
    var id = webcamElement.webcam.id;
    for (var i = 0; i < urls.length; i++) {
    	if (urls[i] == id && i < urls.length - 1) {
  	    var old = urls[i + 1];
  	    urls[i + 1] = id;
  	    urls[i] = old;
  	    break;
  	  }
    }  
  }
  saveUrls();
}

function openWebCam(webcamElement) {
  current = webcamElement.webcam;
  
  document.getElementById("TitleText").innerHTML = current.title;
  document.getElementById("WebCam").title = current.title;
  document.getElementById("WebCam").src = document.getElementById("WebCamImage" + current.id).src;
  mobileResize();
  setOptSize(document.images["WebCamImage" + current.id]);  
  
  document.getElementById("Cams").style.display = "none";
  document.getElementById("WebCamSection").style.display = "block";
  //cycle = false;
  //$("WebCamCycle").src = "play.png";
}

function closeWebCamView(event) {
  document.getElementById("WebCamSection").style.display = "none";
  document.getElementById("Cams").style.display = "block";
  document.getElementById("TitleText").innerHTML = "WebCams";
  current = null;
  mobileResize();
}

function openUrl() {
  if (current) {
    widget.openURL(current.url);
  }
  else {
    widget.openURL("http://www.worldwatchr.com");
  }
}

function refresh() {
  if (current) {
    updateWebCam();
  }
  else {
    updateAllWebCams();
  }
}

function updateAllWebCams() {
  var container = document.getElementById("Cams");
  var divs = container.childNodes;
  for (var i = 0; i < divs.length; i++) {
  	loadImage(divs[i].webcam.id, getUrl(divs[i].webcam.url));
  }
}

function updateWebCam(webcamElement) {
  loadImage(current.id, getUrl(current.url));
}

function getUrl(url) {
  var key = new Date().getTime();
  if (url.indexOf("?") >= 0) {
    return url + "&" + key;
  }
  else {
    return url + "?" + key;  
  }    
}

function loadImage(id, url) {
  var loadId = id;
  var element1 = document.getElementById("WebCam");
  var element2 = document.getElementById("WebCamImage" + id);
  if (current && id == current.id) {
    element1.src = "loading.gif";
  }
  element2.src = "loading.gif";
  var img = new Image();  
  img.onload = function() {    
    element2.src = img.src;
    document.images[element2.id].orgWidth = img.width;
    document.images[element2.id].orgHeight = img.height;
    if (current && loadId == current.id) {
      element1.src = img.src;
      setOptSize(document.images[element2.id])
    }  
  }
  img.onerror = function() {
    element2.src = "error.png";
    document.images[element2.id].orgWidth = 320;
    document.images[element2.id].orgHeight = 240;
    if (current && loadId == current.id) {
      element1.src = "error.png";
      setOptSize(document.images[element2.id])
    }  
  }
  img.src = url;
}

function setOptSize(image) {
  var img = document.getElementById("WebCam");
  var imgWidth = width;//$("WebCamSection").clientWidth;
  var imgHeight = height;//$("WebCamSection").clientHeight;
  var x = 0;
  var y = 0;
  if (height > 0) {
    if (image.orgWidth * imgHeight > image.orgHeight * imgWidth) {
      img.width = imgWidth;
      img.height = imgWidth * image.orgHeight / image.orgWidth;
      y = (imgHeight - imgWidth * image.orgHeight / image.orgWidth) / 2
      if (widget.mobile) {
        y = 0;
      }
    }
    else {
      img.width = imgHeight * image.orgWidth / image.orgHeight;
      img.height = imgHeight;      
      x = (imgWidth - imgHeight * image.orgWidth / image.orgHeight) / 2;
    }
  }
  else {
    img.width = width;
    img.height = width * image.orgHeight / image.orgWidth;
  }
  img.style.left = x + "px";
  img.style.top = y + "px";
}

function autoUpdate() {
  updateAllWebCams();
  startAutoUpdate();
}

function startAutoUpdate() {
  stopAutoUpdate();
  var time = document.getElementById("AutoUpdate").value;
  if (time > 0) {
    updateTimer = setTimeout(autoUpdate, time * 60000);
  }
  widget.setPreferenceForKey(time, widget.identifier + "-refresh")
}

function stopAutoUpdate() {
  if (updateTimer) {
    clearTimeout(updateTimer);    
  }
  updateTimer = null;  
}

function reloadWebCams(ids) {
  ;
  for (var i = 0; i < ids.length; i++) {
	  var url = widget.preferenceForKey(widget.identifier + "-url" + ids[i]);
	  var title = widget.preferenceForKey(widget.identifier + "-title" + ids[i]);
	  var webcam = addWebCam(url, title, ids[i]);    	    
  	lastId = Math.max(lastId, ids[i]);
  }
  lastId++;
}

function saveUrls() {
  var code = "[";
  for (var i = 0; i < urls.length; i++) {
  	if (i > 0) {
  	  code += ",";
  	}
  	code += urls[i];
  }
  code += "]";
  widget.setPreferenceForKey(code, widget.identifier + "-urls");  	  
}

function resize(newWidth, newHeight) {
  window.resizeTo(newWidth, newHeight);
  document.getElementById("Background").style.width = newWidth + "px";
  document.getElementById("Background").style.height = newHeight + "px";  
  width = newWidth - borderWidth;
  height = newHeight - borderHeight;
}

function onresize() {
  if (!backShown) {
    if (window.widget) {
      widget.setPreferenceForKey("" + window.innerWidth, widget.identifier + "-width");
      widget.setPreferenceForKey("" + window.innerHeight, widget.identifier + "-height");
    }      
    width = window.innerWidth - borderWidth;
    height = window.innerHeight - borderHeight;
    if (current) {
      setOptSize(document.images["WebCamImage" + current.id]);
    }  
  }
}

function mobileResize() {
  if (widget.mobile) {
    if (current) {
      resize(300, 400);
    }
    else {
      var cams = document.getElementById("Cams").childNodes.length;
      frontHeight = parseInt(((1 + cams) / 2)) * 81 + borderHeight; 
      resize(274, frontHeight);
    }  
  }
}

function setFrontColor(color) {
  var prefix = "back"
  for (var i = 0; i < tableTd.length; i++) {
  	var element = document.getElementById("Table_" + tableTd[i]);
  	element.setAttribute("background", prefix + "_" + tableTd[i] + "_" + color + ".png");
  }
  for (var i = 0; i < tableImg.length; i++) {
  	var element = document.getElementById("Table_" + tableImg[i]);
  	element.src = prefix + "_" + tableImg[i] + "_" + color + ".png";
  }
  document.getElementById("Table_c").style.backgroundColor = color;
  if (titleColors[color] != null) {
    document.getElementById("Title").style.color = titleColors[color];
  }
  else {
    document.getElementById("Title").style.color = null;    
  }
  if (backColors[color] != null) {
    document.getElementById("Table_c").style.backgroundColor = backColors[color];
  }
  else {
    document.getElementById("Table_c").style.backgroundColor = color;    
  }
  widget.setPreferenceForKey(color, widget.identifier + "-color");
}

function updateFront(){
  var color = document.getElementById("FrontColor").value;
  setFrontColor(color);
  widget.setPreferenceForKey(color, widget.identifier + "-color");
  
  window.resizeTo(frontWidth, frontHeight);  
}

function showHelp() {
  document.getElementById("Help").style.display = "block";
}

function closeHelp() {
  document.getElementById("Help").style.display = "none";  
}

function widgetSetup() {
  if (window.widget) {
  	var gAddButton = new AppleGlassButton(document.getElementById("AddButton"), 
  	                                      "Add Cam", addCam); 
  	var gDoneButton = new AppleGlassButton(document.getElementById("DoneButton"), 
  	                                      "Done", hideBack); 
  	var gHelpButton = new AppleGlassButton(document.getElementById("HelpButton"), 
  	                                      "Help", showHelp); 
	  var gInfoButton = new AppleInfoButton(document.getElementById("InfoButton"), 
	                                        document.getElementById("front"), 
	                                        "black", "white", showBack);
	  gInfoButton.setCircleOpacity(0.8);                                          
	  var resizeButton = new Resizer(window, 
	                                 document.getElementById("ResizeButton"),
	                                 document.getElementById("Background"), onresize);    
  }
}

function showBack() {
    var front = document.getElementById("front");
    var back = document.getElementById("back");
 
 
    backShown = true;
    frontWidth = window.innerWidth;
    frontHeight = window.innerHeight;
    window.resizeTo(backWidth, backHeight);
    stopAutoUpdate();
    front.style.display="none";
    if(window.widget)
        widget.prepareForTransition("ToBack");
    back.style.display="block";
 
    if (window.widget)
        setTimeout ('widget.performTransition();', 0);  
}

function hideBack() {
    var front = document.getElementById("front");
    var back = document.getElementById("back");
 
 
    backShown = false;
    updateFront();
    startAutoUpdate();
    back.style.display="none";
    if (window.widget)
        widget.prepareForTransition("ToFront");
    front.style.display="block";
 
    if (window.widget)
        setTimeout ('widget.performTransition();', 0);
}  